config/routes.rb
Rails.application.routes.draw do
  devise_for :users
  root to: 'staff/dashboard#show' 
  # For details on the DSL available within this file, see http://guides.rubyonrails.org/routing.html

  namespace :staff do
    resource :dashboard, controller: :dashboard do
      collection do
        get :tats
        get :reports
        get :staffs_report
        get :executives_report
      end
    end
      resources :cases do
      collection do
        get :upload_file
        post :upload_mapping
        post :upload
        get :search
        put :bulk_assignment
        get :out_of_tats
        get :today_tats
        get :tomorrow_tats
      end
      member do
        get  :mark_approved
        post :upload_attachment
        post :upload_verification_detail
        get :crop_attachment
      end

      resources :attachments
    end
    resources :clients
    resources :users
  end

  namespace :executive do
    resources :cases do
      collection do
        get :verification_completed
        get :print_all
      end
      member do
        post :upload_attachment
        get :template
        post :upload_verification_detail
        get  :mark_verification_completed
        get :redo
        post :set_untraceable
      end
    end
  end
end

app/controllers/staff/attachments_controller.rb
class Staff::AttachmentsController < ApplicationController
  before_action :find_case
  before_action :find_attachment

  def show
  end

  private
    def find_case
      @case = Case.find params[:case_id]
    end

    def find_attachment
      @attachment = @case.attachments.find params[:id]
    end
end

app/controllers/staff/cases_controller.rb
class Staff::CasesController < ApplicationController
  require 'csv'

  before_action :find_case, only: %w(show crop_attachment)

  include UploadMappings

  def index
    @users = User.where(role: 'executive')
    @clients =Client.all
    @cases = Case.where.not(status: 'approved').order(created_at: :desc)
  end

  def tats
  end

  def out_of_tats
    @users = User.where(role: 'executive')
    @cases = Client.total_out_of_tats
    render action: :index
  end

  def today_tats 
    @users = User.where(role: 'executive')
    @cases = Client.total_tats_today
    render action: :index
  end

  def tomorrow_tats
    @users = User.where(role: 'executive')
    @cases = Client.total_tats_tomorrow
    render action: :index
  end

  def upload_file
    @clients = Client.all
  end

  def upload_mapping
    @clients = Client.all
    if params[:csv].present?
      @csv = CSV.parse(params[:csv].read, headers: true)
      @client = Client.find(params[:client_id])
      fn = "upload_mapping_#{@client.client_format}_#{params[:case_type]}"
      if respond_to?(fn)
        if (@cases = send(fn))
          session[:cases] = @cases
        else
          render action: :upload_file
        end
      else
        flash[:notice] = "Selected type is not supported"
        render action: :upload_file
      end
    else
      flash[:notice] = "Please upload the file"
      render action: :upload_file
    end
  end

  def upload
    session[:cases].each do |c|
      #ca = Case.find_or_initialize_by(client_ref_no: c['client_ref_no'])
      #ca.attributes = c
      #ca.save!
      c.stringify_keys!
      @cases = Case.find_by(client_ref_no: c['client_ref_no'])
      if @cases.present?
        @cases.update_attributes(c)
      else
        Case.open.create!(c)
      end
    end
    redirect_to staff_cases_path
  end

  def show 
    @case = Case.find(params[:id])
    @case_investigation = CaseInvestigation.find_by(case_id: @case.id, user_id:  @case.user_id)
    unless @case_investigation.present?
      @case_investigation = CaseInvestigation.new
    end
  end


  def upload_attachment
    attachment_params.each do |attach_param|
      if attach_param[:document].present?
        attachment = Attachment.new(attach_param)
        attachment.case_id = @case.id
        attachment.user_id = current_user.id
        attachment.save!
      end
    end
  end

  def upload_verification_detail
    @case = Case.find(params[:id])
    @verified_case = CaseInvestigation.find_by(case_id: @case.id, user_id: @case.user_id)

    if @verified_case.present?
      @verified_case = @verified_case.update_attributes(case_investigation_params)
    else
      @verified_case = CaseInvestigation.new(case_investigation_params)
      @verified_case.case_id = @case.id
      @verified_case.user_id = current_user.id
      @verified_case.save!
    end
    redirect_to staff_case_path(@case)
  end


  def mark_approved
    @case = Case.find(params[:id])
    if @case.status == "verification_completed"
      @case.staff_id = current_user.id
      @case.status = "approved"
      @case.save!
    end
      redirect_to staff_cases_path
  end

  def search
    params[:search] ||= {}
    @users = User.where(role: 'executive')
    @cases = Case.where("1=1")
    @cases = @cases.where(status: params[:search][:status]) if params[:search][:status].present?
    
    if params[:search][:query].present?
      query = '%' + params[:search][:query] + '%'
      @cases = @cases.where("address ILIKE ?", query)
    end

    if params[:search][:client_id].present?
      @cases = @cases.where(client_id: params[:search][:client_id])
    end

    if params[:search][:user_id].present?
      @cases = @cases.where(user_id: params[:search][:user_id])
    end

    if params[:search][:case_type].present?
      @cases = @cases.where(case_type: params[:search][:case_type]) 
    end

    respond_to do |format|
      format.html { render action: :index }
      format.csv { send_data @cases.to_csv, filename: "cases-#{Date.today}.csv" }
    end
  end




  def bulk_assignment
    if params[:case_ids].present?
      params[:case_ids].each do |case_id|
        c = Case.find(case_id)
        c.update_attributes user_id: params[:user_id], status: "in_progress"
      end
    else
      flash[:notice] = "select cases"
    end
    redirect_to staff_cases_path
  end

  def crop_attachment
    @attachment = @case.attachments.find(params[:attachment_id])
  end

  def attachment_params
    params.require(:attachments).map{|p| p.permit(:document)}
  end

  def case_investigation_params
    params.require(:case_investigation).permit(:visited_at, :address_changed, :land_mark, :locality, :accommodation_type, :duration_of_stay, :building_color, :building_type, :id_number, :respondent_name, :respondent_relationship, :respondent_contact_no, :police_station_name, :remarks, extras: {})
  end

  def find_case
    @case = Case.find(params[:id])
  end
end

app/controllers/staff/clients_controller.rb
class Staff::ClientsController < ApplicationController

  def new
    @client = Client.new
  end

  def create
    @client = Client.new(client_params)
    if @client.save
      redirect_to staff_clients_path
    else
      render action: :new
    end
  end

  def index
    @clients = Client.all.order(created_at: :asc)
  end

  def update
    @client = Client.find(params[:id])
    if @client.update_attributes(client_params)
        flash[:success]="Successfully updated"
        redirect_to staff_clients_path()
      else
        render 'edit'
    end
  end 

  def edit
    @client = Client.find(params[:id])
  end

  private

    def client_params
      params.require(:client).permit(:name,:email,:client_format)
    end
end

app/controllers/staff/dashboard_controller.rb
class Staff::DashboardController < ApplicationController

  def show
    @cases = Case.all
    @executives = User.where(role: 'executive')
    @staffs = User.where(role: 'staff')
  end



  def reports
  end

  def staffs_report
    @user = User.find(params[:staff_id])
    @cases = Case.where(staff_id: @user.id, status: ["approved"])
    render action: :reports
  end

  def executives_report
    @user = User.find(params[:executive_id])
    @cases = Case.where(user_id: @user.id, status: ["approved", "verification_completed"])
    render action: :reports
  end

end

app/controllers/staff/users_controller.rb
class Staff::UsersController < ApplicationController

  def new
    @user = User.new()
  end

  def create
    @user = User.new(user_params)
    respond_to do |format|
      if @user.save
        redirect_to staff_users_path
        else
        render action: :new
      end
    end 
  end

  def index
    @users = User.all.order(created_at: :asc)
  end


  def update
    @user = User.find(params[:id])
    @user.update_attributes(user_params)
    render 'edit'
  end 


  def edit
    @user = User.find(params[:id])
  end

  private

    def user_params
      params.require(:user).permit(:name, :l_name, :dob, :id_proof, :photo,  :email, :password, :phone, :address, :role, :password_confirmation)
    end

end

app/helpers/staff/attachments_helper.rb
module Staff::AttachmentsHelper
end

app/helpers/staff/cases_helper.rb
module Staff::CasesHelper
end

app/helpers/staff/clients_helper.rb
module Staff::ClientsHelper
end

app/helpers/staff/dashboard_helper.rb
module Staff::DashboardHelper
end

app/helpers/staff/users_helper.rb
module Staff::UsersHelper
end

app/views/staff/dashboard/reports.html.erb
<div class="row">
  <div class="col">
    <div class="card card-small mb-4">
      <% if @cases.present? %>
        <div class="card-header border-bottom">
          <h6 class="m-0"><%= @user.name %>'s  &nbspReport</h6>
        </div>
        <div class="card-body p-0 pb-3 text-center">
          <table class="table mb-0">
            <thead class="bg-light">
              <tr>
                <th class="border-0">Name</th>
                <th class="border-0">Ref No</th>
                <th class="border-0">status</th>
              </tr>
            </thead>
            <tbody>
              <% @cases.each do |c| %>&nbsp
                <tr>
                  <td><%= c.candidate_name %></td>
                  <td><%= c.client_ref_no %></td>
                  <td><%= c.status %></td>
                </tr>
              <% end %>
            </tbody>
          </table>
      </div>
      <% else %>
        <strong> You don't have cases </strong>
      <% end %>
    </div>
  </div>
</div>

app/views/staff/dashboard/show.html.erb
<div class="main-content-container container-fluid px-4">
  <div class="page-header row no-gutters py-4">
    <div class="col-12 col-sm-4 text-center text-sm-left mb-0">
      <span class="text-uppercase page-subtitle">Dashboard</span>
      <h3 class="page-title">Overview</h3>
    </div>
  </div>

  <div class="row">
    <div class="col-lg col-md-6 col-sm-6 mb-4">
    <%= link_to out_of_tats_staff_cases_path(), style: "text-decoration: none" do %>
      <div class="stats-small stats-small--1 card card-small">
        <div class="card-body p-0 d-flex">
          <div class="d-flex flex-column m-auto">
            <div class="stats-small__data text-center">
              <span class="stats-small__label text-uppercase">Out of TAT</span>
              <h6 class="stats-small__value count my-3"><%= Client.total_out_of_tats_count %></h6>
            </div>
          </div>
        </div>
      </div>
    <% end %>
    </div>
    <div class="col-lg col-md-6 col-sm-6 mb-4">
      <%= link_to tomorrow_tats_staff_cases_path(), style: "text-decoration: none" do %>
        <div class="stats-small stats-small--1 card card-small">
          <div class="card-body p-0 d-flex">
            <div class="d-flex flex-column m-auto">
              <div class="stats-small__data text-center">
                <span class="stats-small__label text-uppercase">1day to TAT</span>
                <h6 class="stats-small__value count my-3"><%= Client.total_tats_tomorrow_count %></h6>
              </div>
            </div>
          </div>
        </div>
      <% end %>
    </div>
    <div class="col-lg col-md-4 col-sm-6 mb-4">
      <%= link_to today_tats_staff_cases_path(), style: "text-decoration: none" do %>
        <div class="stats-small stats-small--1 card card-small">
          <div class="card-body p-0 d-flex">
            <div class="d-flex flex-column m-auto">
              <div class="stats-small__data text-center">
                <span class="stats-small__label text-uppercase">Today's TAT</span>
                <h6 class="stats-small__value count my-3"><%= Client.total_tats_today_count %></h6>
              </div>
            </div>
          </div>
        </div>
      <% end %>
    </div>
  </div>


  <div class="row">
    <div class="col-lg col-md-6 col-sm-6 mb-4">
      <%= link_to search_staff_cases_path(search: {status: 'open'}), style: "text-decoration: none" do %>
        <div class="stats-small stats-small--1 card card-small">
          <div class="card-body p-0 d-flex">
            <div class="d-flex flex-column m-auto">
                <div class="stats-small__data text-center">
                  <span class="stats-small__label text-uppercase">New Load</span>
                  <h6 class="stats-small__value count my-3"><%= @cases.where(status: "open").count %></h6>
                </div>
            </div>
          </div>
        </div>
      <% end %>
    </div>
    <div class="col-lg col-md-4 col-sm-6 mb-4">
      <%= link_to search_staff_cases_path(search: {status: 'in_progress'}), style: "text-decoration: none" do %>
        <div class="stats-small stats-small--1 card card-small">
          <div class="card-body p-0 d-flex">
            <div class="d-flex flex-column m-auto">
              <div class="stats-small__data text-center">
                <span class="stats-small__label text-uppercase">Current load</span>
                <h6 class="stats-small__value count my-3"><%= @cases.where(status: "in_progress").count %></h6>
              </div>
            </div>
          </div>
        </div>
      <% end %>
    </div>

    <div class="col-lg col-md-6 col-sm-6 mb-4">
      <%= link_to search_staff_cases_path(search: {status: 'verification_completed'}), style: "text-decoration: none" do %>
        <div class="stats-small stats-small--1 card card-small">
          <div class="card-body p-0 d-flex">
            <div class="d-flex flex-column m-auto">
              <div class="stats-small__data text-center">
                <span class="stats-small__label text-uppercase">Pending review</span>
                <h6 class="stats-small__value count my-3"><%= @cases.where(status: "verification_completed").count %></h6>
              </div>
            </div>
          </div>
        </div>
      <% end %>
    </div>

    <div class="col-lg col-md-6 col-sm-6 mb-4">
      <%= link_to search_staff_cases_path(search: {status: 'approved'}), style: "text-decoration: none" do %>
        <div class="stats-small stats-small--1 card card-small">
          <div class="card-body p-0 d-flex">
            <div class="d-flex flex-column m-auto">
              <div class="stats-small__data text-center">
                <span class="stats-small__label text-uppercase">Approved Cases</span>
                <h6 class="stats-small__value count my-3"><%= @cases.where(status: "approved").count %></h6>
              </div>
            </div>
          </div>
        </div>
      <% end %>
    </div>

  </div>

  <% if current_user.role == "admin" %>
  <div class="row">
    <div class="col-lg-6 col-md-12 col-sm-12 mb-4">
      <div class="card card-small">
        <div class="card-header border-bottom">
          <h6 class="m-0">Staffs</h6>
        </div>
        <div class="card-body">
           <table border="1px;" style="width: 500px; margin: auto;"> 
              <th>Name</th>
              <th>No of Cases Attended</th>
              <tbody>
                <% if @staffs.present? %>
                  <% @staffs.each do |s| %>
                  <td><%= link_to s.name, staffs_report_staff_dashboard_path(staff_id: s.id), style: "text-decoration: none"%></td>
                  <td><%= Case.where(staff_id: s.id, status: ["approved"]).count %></td>
                  <% end %>
                <% end %>
              </tbody>
            </table>
        </div>
      </div>
    </div>
    <div class="col-lg-6 col-md-6 col-sm-12 mb-4">
      <div class="card card-small h-100">
        <div class="card-header border-bottom">
          <h6 class="m-0">executives</h6>
        </div>
        <div class="card-body">
          <table border="1px;" style="width: 500px; margin: auto;"> 
              <th>Name</th>
              <th>No of Cases Attended</th>
              <tbody>
                <% if @executives.present? %>
                  <% @executives.each do |e| %>
                    <td>
                      <%= link_to e.name, executives_report_staff_dashboard_path(executive_id: e.id) %>
                    </td>
                    <td>
                      <%= Case.where(user_id: e.id, status: ["approved", "verification_completed"]).count %>
                    </td>
                    </div>
                  <% end %>
                <% end %>
              </tbody>
            </table>
        </div>
        <!--<div class="card-footer border-top">
          <div class="row">
            <div class="col">
              <select class="custom-select custom-select-sm" style="max-width: 130px;">
                <option selected="">Last Week</option>
                <option value="1">Today</option>
                <option value="2">Last Month</option>
              </select>
            </div>
            <div class="col text-right view-report">
              <a href="#">Full report →</a>
            </div>
          </div>
        </div>-->
      </div>
    </div>
  </div>
  <% end %>

</div>

app/views/staff/dashboard/tats.html.erb
<div class="row">
  <div class="col">
    <div class="card card-small mb-4">

      <% if @out_tats.present? %>
        <div class="card-body p-0 pb-3 text-center">
          <table class="table mb-0">
            <thead class="bg-light">
                <th class="border-0" style="width: 200px;">Candidate/Address</th>
                <th class="border-0">Ref No</th>
                <th class="border-0">Executive</th>
              </tr>
            </thead>
            <tbody>
              <% @out_tats.each do |c| %>
                <tr>
                  <td><%= link_to staff_case_path(c) do %><%= c.candidate_name %><br /><small><%= c.address %></small><% end %></td>
                  <td><%= c.client_ref_no %></td>
                  <td>
                    <%= c.user&.name %>
                    <br />
                    <span class="badge badge-pill badge-dark"><%= c.status %></span>
                  </td>
                </tr>
              <% end %>
            </tbody>
          </table>
        </div>
        <% elsif @today_tats.present? %>
          <div class="card-body p-0 pb-3 text-center">
            <table class="table mb-0">
              <thead class="bg-light">
                  <th class="border-0" style="width: 200px;">Candidate/Address</th>
                  <th class="border-0">Ref No</th>
                  <th class="border-0">Executive</th>
                </tr>
              </thead>
              <tbody>
                <% @today_tats.each do |c| %>
                  <tr>
                    <td><%= link_to staff_case_path(c) do %><%= c.candidate_name %><br /><small><%= c.address %></small><% end %></td>
                    <td><%= c.client_ref_no %></td>
                    <td>
                      <%= c.user&.name %>
                      <br />
                      <span class="badge badge-pill badge-dark"><%= c.status %></span>
                    </td>
                  </tr>
                <% end %>
              </tbody>
            </table>
          </div>
        <% elsif @tomorrow_tats.present? %>
          <div class="card-body p-0 pb-3 text-center">
            <table class="table mb-0">
              <thead class="bg-light">
                  <th class="border-0" style="width: 200px;">Candidate/Address</th>
                  <th class="border-0">Ref No</th>
                  <th class="border-0">Executive</th>
                </tr>
              </thead>
              <tbody>
                <% @tomorrow_tats.each do |c| %>
                  <tr>
                    <td><%= link_to staff_case_path(c) do %><%= c.candidate_name %><br /><small><%= c.address %></small><% end %></td>
                    <td><%= c.client_ref_no %></td>
                    <td>
                      <%= c.user&.name %>
                      <br />
                      <span class="badge badge-pill badge-dark"><%= c.status %></span>
                    </td>
                  </tr>
                <% end %>
              </tbody>
            </table>
          </div>
        <% else %>
        <strong> You don't have Cases </strong>
      <%end %>

    </div>
  </div>
</div>